杭电OJ1973/哈理工OJ1534 Prime Path(搜索)bfs


Prime Path

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 515    Accepted Submission(s): 337


Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
—I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
—In fact, I do. You see, there is this programming contest going on. . .

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
 

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
 

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
 

Sample Input
  
  
3 1033 8179 1373 8017 1033 1033
 

Sample Output
  
  
6 7 0
 
这个题目还是有点坑的,无脑做题不细心的孩纸要注意咯~~~~~

这个题还是比较简单的。但是操作比较复杂,整理操作的时候容易出错,这里我们为了优化代码,耗时减少,我们打印素数表的时候使用快速打印的方式:

        for(int j=2;j<sqrt(max);j++)
        {
            if(Is_or[j]==0)//去掉合数的倍数.
            for(int k=j+j;k<=max;k+=j)//去掉倍数.(把这么些个合数的倍数都标记上这个数不是素数.)
            Is_or[k]=1;//这里表示合数为1 素数为0;
        }
我们有了素数表之后,就可以判断变化的数字是否是素数了。

我们这里利用广搜来做:

贴上完整的AC代码:

#include<stdio.h>
#include<queue>
#include<math.h>
#include<string.h>
using namespace std;
struct shusu
{
    int num[4];
    int output;
}now,nex;
#define max 10005
int Is_or[max];//0是素数
int mubiao[4];
int vis[10][10][10][10];//vis函数我们这里用四维.
char a[5];
char b[5];
void bfs()
{
    memset(vis,0,sizeof(vis));
    for(int i=0;i<4;i++)
    {
        now.num[i]=a[i]-'0';
        mubiao[i]=b[i]-'0';
    }
    now.output=0;
    vis[now.num[0]][now.num[1]][now.num[2]][now.num[3]]=1;
    queue<shusu>s;
    s.push(now);
    while(!s.empty())
    {
        now=s.front();
        //printf("%d%d%d%d",now.num[0],now.num[1],now.num[2],now.num[3]);
        if(now.num[0]==mubiao[0]&&now.num[1]==mubiao[1]&&now.num[2]==mubiao[2]&&now.num[3]==mubiao[3])
        {
            printf("%d\n",now.output);
            return ;
        }
        s.pop();
        for(int i=0;i<4;i++)
        {
            if(i==0)
            {
                for(int j=1;j<=9;j++)//这里注意,千位数字不能是0,如果有0,是会WA的.
                {
                    nex=now;
                    if(j!=now.num[0])
                    nex.num[0]=j;
                    int sum=nex.num[3]+10*nex.num[2]+100*nex.num[1]+1000*nex.num[0];
                    if(Is_or[sum]==0&&vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]==0)
                    {
                        //printf("%d\n",sum);
                        nex.output=now.output+1;
                        s.push(nex);
                        vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]=1;
                    }
                }
            }
            if(i==1)
            {
                for(int j=0;j<=9;j++)
                {
                    nex=now;
                    if(j!=now.num[1])
                    nex.num[1]=j;
                    int sum=nex.num[3]+10*nex.num[2]+100*nex.num[1]+1000*nex.num[0];
                    //printf("%d %d %d %d\n",nex.num[0],nex.num[1],nex.num[2],nex.num[3]);
                    if(Is_or[sum]==0&& vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]==0)
                    {
                        //printf("%d\n",sum);
                        nex.output=now.output+1;
                        s.push(nex);
                        vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]=1;
                    }
                }
            }
            if(i==2)
            {
                for(int j=0;j<=9;j++)
                {
                    nex=now;
                   if(j!=now.num[2])
                    nex.num[2]=j;
                    int sum=nex.num[3]+10*nex.num[2]+100*nex.num[1]+1000*nex.num[0];
                    if(Is_or[sum]==0&& vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]==0)
                    {
                        //printf("%d\n",sum);
                        nex.output=now.output+1;
                        s.push(nex);
                        vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]=1;
                    }
                }
            }
            if(i==3)
            {
                for(int j=0;j<=9;j++)
                {
                    nex=now;
                    if(j!=now.num[3])
                    nex.num[3]=j;
                    int sum=nex.num[3]+10*nex.num[2]+100*nex.num[1]+1000*nex.num[0];
                    if(Is_or[sum]==0&& vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]==0)
                    {
                       // printf("%d\n",sum);
                        nex.output=now.output+1;
                        s.push(nex);
                        vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]=1;
                    }
                }
            }
        }
    }
    printf("Impossible\n");
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
       scanf("%s%s",a,b);
        //秒打印素数表.
        for(int j=2;j<sqrt(max);j++)
        {
            if(Is_or[j]==0)//去掉合数的倍数.
            for(int k=j+j;k<=max;k+=j)//去掉倍数.(把这么些个合数的倍数都标记上这个数不是素数.)
            Is_or[k]=1;
        }
        //printf("%d %d\n",Is_or[1033],Is_or[1733]);
        bfs();
        /*for(int i=1;i<50;i++)
        {
            printf("%d ",Is_or[i]);
        }*/
    }
}



























  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值